      .586                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive 

    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\msvcrt.inc
    include \masm32\include\debug.inc
    
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\msvcrt.lib
    includelib \masm32\lib\debug.lib


    include \masm32\macros\macros.asm

      .data
        hInstance            dd ?
        CurDir               db MAX_PATH dup (?)
        TempPath             db MAX_PATH dup (?)
        Len_MMF              dd 64 * 1024 
        Len_HBuffer          dd ? 
        ProcessHandle        dd ? 
        ProcessId            dd ? 
        MMF_Nr               dd ? 
        MMF_NrChr            db 12 dup (?) 
        MMF_Name             dd 24 dup (?)
        MMF_Handle           dd ? 
        MMF_Pointer          dd ? 
        ExitCode             dd ? 
        MMF_X                db "shellmmf" , 0    
      .code

; 
; 

align 4

ShellX proc uses ebx ecx edx edi esi , 
           pNextProg:dword,        ; Program to be called (  COBOL : pic x(260) )
           LenBuffer:dword,        ; length of buffer 
           pBuffer:dword           ; pointer to buffer

LOCAL SysInfo   :SYSTEM_INFO
LOCAL StUpInfo  :STARTUPINFO
LOCAL ProcInfo  :PROCESS_INFORMATION

        mov eax, LenBuffer
        .if eax > Len_MMF
            mov eax, Len_MMF             ; max defined length of buffer
        .endif   
        mov Len_HBuffer, eax       
                                        
        
@@:

  ; ----------------------------
  ; zero fill the two structures
  ; ----------------------------
      mov ecx, SIZEOF STARTUPINFO
      lea edi, StUpInfo
      xor eax, eax
      rep stosb
      mov StUpInfo.cb, SIZEOF STARTUPINFO                           ; set the structure size AFTER
                                                                    ; zero filling the rest
      mov ecx, SIZEOF PROCESS_INFORMATION
      lea edi, ProcInfo
      xor eax, eax
      rep stosb
  
     invoke GetCurrentDirectoryA, SIZEOF CurDir, ADDR CurDir        ; save home dir        
     invoke GetSystemInfo, ADDR SysInfo
     invoke GetStartupInfo,ADDR StUpInfo
                                                                    ; create process in suspended mode
     invoke CreateProcessA, NULL, pNextProg,NULL,NULL,TRUE,\        
                       NORMAL_PRIORITY_CLASS+CREATE_SUSPENDED,\
                       NULL,NULL,ADDR StUpInfo, ADDR ProcInfo

     .if eax == 0
        mov eax, 35             ; 35 = COBOL-Error code "File not found"
        ret
     .else
        mov ProcessHandle, eax
        mov eax, ProcInfo.dwProcessId
        mov MMF_Name, 0
        mov eax, cat$(ADDR MMF_Name, ADDR MMF_X, ustr$(eax))   ; create unique mmf-name
     .endif

     invoke GetPathOnly, pNextProg, ADDR TempPath
     invoke SetCurrentDirectoryA,   ADDR TempPath              ; change to path of NextProg

     .if Len_HBuffer > 0                                       ; create unique named MMF
         invoke CreateFileMappingA, -1,0,PAGE_READWRITE,\     
                                    0, Len_MMF, ADDR MMF_Name  
         .if eax == 0
            invoke TerminateProcess, ProcessHandle, 0
            mov eax, 99
            ret         
         .else
            mov MMF_Handle, eax
         .endif

         invoke MapViewOfFile, MMF_Handle, FILE_MAP_WRITE, 0,0,0
         .if eax == 0
            invoke CloseHandle, MMF_Handle
            invoke TerminateProcess, ProcessHandle, 0
            mov eax, 99
            ret         
         .endif

         mov MMF_Pointer, eax
         invoke MemCopy, pBuffer, MMF_Pointer, Len_HBuffer     ; copy buffer to MMF 
     .endif

     invoke ResumeThread, ProcInfo.hThread                     ; start NextProg
     invoke WaitForSingleObject, ProcInfo.hProcess, INFINITE   ; waiting ..... 
     lea eax, ExitCode
     invoke GetExitCodeProcess, ProcInfo.hProcess, eax         ; cleanup process
     invoke CloseHandle, ProcInfo.hThread
     invoke CloseHandle, ProcInfo.hProcess                  

     .if Len_HBuffer > 0                                       ; copy MMF to buffer
        invoke MemCopy, MMF_Pointer, pBuffer, Len_HBuffer      ; cleanup MMF
        invoke UnmapViewOfFile, MMF_Pointer
        invoke CloseHandle, MMF_Handle
     .endif

     invoke SetCurrentDirectoryA, ADDR CurDir                      ; back home
     mov eax, ExitCode
     ret

ShellX EndP

; 
GetShellBuffer proc uses ebx ecx edx edi esi , 
           LenBuffer:dword,         
           pBuffer:dword           
; 
Local BLen : DWORD
      mov eax, LenBuffer                                            ; checking bufferlength
      .if eax > Len_MMF
        mov eax, Len_MMF                                            ; truncated to max defined length
      .endif   
      mov BLen, eax             
      invoke GetCurrentProcessId
      mov MMF_Name, 0
      mov eax, cat$(ADDR MMF_Name, ADDR MMF_X, ustr$(eax))          ; create unique mmf-name      
      invoke OpenFileMappingA, FILE_MAP_WRITE, 1, ADDR MMF_Name
      .if eax != 0                                                  ; no MMF available
        invoke MapViewOfFile, eax, FILE_MAP_WRITE, 0,0,0
        .if eax != 0
            invoke MemCopy, eax, pBuffer, BLen                      ; write MMF to buffer 
            mov eax, 1
        .endif    
      .endif
      ret                                                           ; returns 1 if module is called via "ShellX"
GetShellBuffer EndP

; 
ExitShell proc uses ebx ecx edx edi esi , 
           LenBuffer:dword,         
           pBuffer:dword           
; 
Local BLen : DWORD
      mov eax, LenBuffer                                            ; checking bufferlength
      .if eax > Len_MMF
        mov eax, Len_MMF
      .endif   
      mov BLen, eax        

      invoke GetCurrentProcessId
      mov MMF_Name, 0
      mov eax, cat$(ADDR MMF_Name, ADDR MMF_X, ustr$(eax))          ; create unique mmf-name
      invoke OpenFileMappingA, FILE_MAP_WRITE, 1, ADDR MMF_Name
      .if eax != 0                                                  ; else no MMF available 
          invoke MapViewOfFile, eax, FILE_MAP_WRITE, 0,0,0
          .if eax != 0                                      
             invoke MemCopy, pBuffer, eax, BLen                     ; write buffer to MMF          
             mov eax, 1                                             ; returns 1 if OK
          .endif
      .endif   
      ret
ExitShell EndP

end